/* ====================================
		gdi++Manager
		main & util
==================================== */
#include "stdafx.h"
#include "gdippManager.h"


/* ====================================
		ϐ
==================================== */
static const TCHAR WINCL_NAME[] = TEXT("gdi++Manager");
static const TCHAR DLL_NAME[]   = TEXT("gdi++.dll");
static const CHAR HOOK_PROC[]   = "GetMsgProc";

HHOOK g_hHook = NULL;
TCHAR g_dllPath[MAX_PATH] = TEXT("");


/* ====================================
		`
==================================== */
// main
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpCmdLine, int)
{
	HWND        hwnd;
	MSG         msg;
	WNDCLASSEX  wincl;

	HANDLE      hMutex = CreateMutex(FALSE, 0, WINCL_NAME);
	if(GetLastError() == ERROR_ALREADY_EXISTS) {
		CloseHandle(hMutex);
		MessageBox(NULL, TEXT("dN͂ł܂B"), NULL, MB_ICONSTOP);
		return 0;
	}

	// APIȂ('A`)
	if (GetVersion() & 0x80000000) {
		MessageBox(NULL, TEXT("Win9xł͓삵܂B"), NULL, MB_ICONSTOP);
		return 0;
	}

	wincl.cbSize        = sizeof(WNDCLASSEX);
	wincl.style         = CS_DBLCLKS;
	wincl.lpfnWndProc   = WndMainProc;
	wincl.cbClsExtra    = wincl.cbWndExtra = 0;
	wincl.hInstance     = hInstance;
	wincl.hIcon         = wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
	wincl.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wincl.hbrBackground = NULL;
	wincl.lpszMenuName  = NULL;
	wincl.lpszClassName = WINCL_NAME;
	if (!RegisterClassEx(&wincl)) { return 1; }

	hwnd = CreateWindowEx(0, WINCL_NAME, WINCL_NAME,	WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT,	CW_USEDEFAULT, CW_USEDEFAULT,
		HWND_DESKTOP, NULL, hInstance, NULL);
	if (hwnd == NULL) { return 1; }

	if (lstrcmpi(lpCmdLine, TEXT("-on")) == 0) { InitializeHook(); }
	if (lstrcmpi(lpCmdLine, TEXT("\"-on\"")) == 0) { InitializeHook(); }

	while ((GetMessage(&msg, NULL, 0, 0) > 0)) {
		DispatchMessage(&msg);
		TranslateMessage(&msg);
	}
	CloseHandle(hMutex);
	return (int)msg.wParam;
}


// ʒm̈ɃACRo^
bool SetTaskTrayIcon(HWND hwnd, PNOTIFYICONDATA lpni)
{
	lpni->cbSize           = sizeof(NOTIFYICONDATA);
	lpni->hIcon            = (HICON)LoadImage(GetModuleHandle(NULL),
															MAKEINTRESOURCE(IDI_GDIPPMANAGER), IMAGE_ICON, 16, 16, 0);
	lpni->hWnd             = hwnd;
	lpni->uCallbackMessage = WM_TRAYICONMESSAGE;
	lpni->uFlags           = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	lpni->uID              = ID_TRAY;
	lstrcpy(lpni->szTip, WINCL_NAME);
	// o^݂
	while (!Shell_NotifyIcon(NIM_ADD, lpni)) {
		if (GetLastError() != ERROR_TIMEOUT) { return false; }
		Sleep(1000);
	}
	return true;
}

// G[\ShellExecute
void ShellExec(HWND hwnd, LPCTSTR path)
{
	HINSTANCE stat = ShellExecute(hwnd, NULL, path, NULL, NULL, SW_SHOWNORMAL);
	if ((int)stat > 32) { return; }

	if (SE_ERR_ASSOCINCOMPLETE == (int)stat) {
		MessageBox(NULL, TEXT("pXJ܂Bt@Cɑ΂Ċ֘At܂"), NULL, MB_ICONSTOP | MB_TOPMOST);

	} else {
		MessageBox(NULL, TEXT("pXJ܂Bt@C܂B"), NULL, MB_ICONSTOP | MB_TOPMOST);
	}
}

// tbNJn
int InitializeHook()
{
	HINSTANCE hinstDLL = LoadLibrary(DLL_NAME);
	HOOKPROC  p        = (HOOKPROC)GetProcAddress(hinstDLL, HOOK_PROC);
	if(!hinstDLL || !p)
		return MessageBox(NULL, TEXT("DLL[hł܂"), NULL, MB_ICONHAND);

	GetModuleFileName(hinstDLL, g_dllPath, sizeof(g_dllPath));
	g_hHook = SetWindowsHookEx(WH_GETMESSAGE, p, hinstDLL, 0);
	if(!g_hHook)
		return MessageBox(NULL, TEXT("tbNɎs܂"), NULL, MB_ICONHAND);
	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
	RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	return TRUE;
}

// tbN
int TerminateHook(BOOL bRedraw/* = TRUE*/)
{
	UnloadALL();
	if (g_hHook) 
		UnhookWindowsHookEx(g_hHook);
	g_hHook = NULL;
	PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
/***/
	if(bRedraw)
		RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	return TRUE;
}

// dll͂
BOOL _RemoteFreeLibrary(DWORD dwProcessId, HMODULE hModule, BOOL bForceUnload = FALSE)
{
	HANDLE hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
									PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
									TRUE, dwProcessId);
	if (!hProcess) return FALSE;

	DWORD  ret = 0;
	DWORD  dwThreadId;
	HANDLE hThread;

	for (;;) {
		hThread = CreateRemoteThread(hProcess, NULL, 0,
									(LPTHREAD_START_ROUTINE)FreeLibrary,
									hModule, 0, &dwThreadId);
		if(!hThread) {
			ret = FALSE;
			break;
		}
		WaitForSingleObject(hThread, INFINITE);
		GetExitCodeThread(hThread, &ret);
		CloseHandle(hThread);

		if(!bForceUnload)
			break;

		if(!ret) {
			ret = TRUE;
			break;
		}
	}

	CloseHandle(hProcess);
	return ret;
}

// vZX񋓂_RemoteFreeLibraryĂ
void UnloadALL() {
	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if(hSnapshot == INVALID_HANDLE_VALUE)
		return;
	PROCESSENTRY32 pe = { sizeof(PROCESSENTRY32) };

	BOOL ret = Process32First(hSnapshot, &pe);

	while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
		HANDLE hSnapModule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
		if(hSnapModule != INVALID_HANDLE_VALUE) {
			MODULEENTRY32 me = { sizeof(MODULEENTRY32) };
			ret = Module32First(hSnapModule, &me);
			while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
//					MessageBox(NULL, me.szExePath, me.szModule, MB_OK);
				if(lstrcmpi(me.szModule, DLL_NAME) == 0) {
					_RemoteFreeLibrary(pe.th32ProcessID, me.hModule, TRUE);
				}
				SetLastError(0);
				ret = Module32Next(hSnapModule, &me);
			}
			CloseHandle(hSnapModule);
		}
		SetLastError(0);
		ret = Process32Next(hSnapshot, &pe);
	}
	CloseHandle(hSnapshot);
}

/***/
// W֐wcsrchrg@ɕύXߖgpɂȂĂ܂
void add_title(LPTSTR path, LPCTSTR title) {
	LPTSTR p = path;

	if(*p == 0) {
		;
	} else if (*title && *(title + 1) == ':') {
		;
	} else if (*title == '\\') {
		if(*p && *(p + 1) == ':') p += 2;
	} else {
		while (*p) {
			if((*p == '\\' || *p == '/') && (*(p + 1) == 0)) { break; }
			p = CharNext(p);
		}
		*p++ = '\\';
	}

	while (*title) {
		*p++ = *title++;
	}
	*p = 0;
}

void del_title(LPTSTR path) {
	LPTSTR p, ep;

	p = ep = path;
	while (*p) {
		if(*p == '\\' || *p == '/') {
			ep = ((p > path) && (*(p-1) == ':')) ? (p+1) : p;
		}
		p = CharNext(p);
	}
	*ep = 0;
}

// EOF
